
proc dnsave { wo g } {
	global news  newsread 

	set w1 "$wo.main"
	set wx "$wo.x"
	set fn [getfile $news(filename)]
	if { $fn == "" } { return }
	set news(filename) $fn
	set om "w"

	if { [file exists $fn]  } {
		set res [tk_dialog .xxme "$news(tclnews) $news(version)" "$fn already exists!" question 0 Append Overwrite Cancel]
		switch $res {
			0 { set om "a" }
			1 { set om "w" }
			2 { return }
		}
	}
	set fd [open $fn $om]

	#  Get a time stamp for the Window name
	set nts [clock format [clock seconds] -format %H%M%S]
	set w ".$nts"
	set txt "G$nts"
	toplevel $w
	wm geometry $w $news(dnload,geo)
	bind $w <Configure> "setgeo $w %W dnload"

	#  Get a seperate connection for this Window
	set news($nts)  [connectit]
	if { $news($nts) == "" } {
		unset news($nts) 
		destroy $w
		return
	}

	#  Configure the header area

	socksend $news($nts) "group $g"
	if { [rescode [readsock $news($nts)] 211] } {
		closewin $nts
		disconnect $news($nts);
		return
	}

	scale $w.s -from 1 -to 100  -variable news($w,scale)  -label "Fetching Article"\
		-showvalue true -orient horizontal -length 400 -state disabled
	pack $w.s

# If multiple files are saved they will go to the same file
# foreach idx [$w1 curselection] 
foreach idx [ordered $wo ] {
	set l1 [$w1 get $idx]

	wm title $w "$l1"

	set a [lindex [split $l1] 0]
	set news($w,scale)   0
	set count 0

	#  Get the header to determine the number of lines
	set l [getheader $a $news($nts)]
	set lines [lindex $l 4]
	$w.s configure -to $lines -label "Fetching Article ($lines lines)"
	socksend $news($nts) "article $a"
	if { [rescode [readsock $news($nts)] 220] } {
		closewin $nts
		disconnect $news($nts);
		return
	}
	update
	
	set res [readsock $news($nts)]
	while { $res != "." } {
		incr count
		if { $count > 5 } {
			incr news($w,scale) $count
			set count 0
			update
		}
		puts $fd $res
		set res [readsock $news($nts)]
	}	
	set newsread($g,$a) $a
	$wx delete $idx
	$wx insert $idx "X"
	}
	disconnect $news($nts);
	close $fd
	closewin $nts
}

